<?php
/**
* @version 1.72: toolbar.SimpleCaddy.html.php
* @copyright Copyright (C) 2009 Henk von Pickartz. All rights reserved.
*/

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class TOOLBAR_simplecaddy {
	function _EDIT( $edit ) {
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		$text = ( $edit ? JText::_( 'Edit' ) : JText::_( 'New' ) );
		JToolBarHelper::title( JText::_( "SimpleCaddy $text" ), 'generic.png'); 

		JToolBarHelper::save( 'save', 'Save' );
		JToolBarHelper::apply();
		if ( $edit ) {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'Close' );
		} else {
			JToolBarHelper::cancel();
		}
	}
	
	function _CONFIG() {
		JToolBarHelper::title( JText::_( 'SimpleCaddy Configuration' )); 
		JToolBarHelper::custom( 'saveconfig', 'save.png', 'save_f2.png', 'Save', false,  false );
		JToolBarHelper::cancel();
		JToolBarHelper::custom( 'control', 'back.png', 'back.png', 'Main', false,  false );
	}

	function _DEFAULT() {
		JToolBarHelper::title( JText::_( 'SimpleCaddy Control Center' )); 
	}

	function _PRODUCTS() {
		JToolBarHelper::title( JText::_( 'SimpleCaddy Products' )); 
		JToolBarHelper::custom( 'duplicate', 'copy.png', 'copy_f2.png', 'Duplicate', false,  false );
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		JToolBarHelper::custom( 'control', 'back.png', 'back.png', 'Main', false,  false );
	}
	
	function _FIELDS() {
		JToolBarHelper::title( JText::_( 'SimpleCaddy Checkout fields' )); 
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		JToolBarHelper::custom( 'control', 'back.png', 'back.png', 'Main', false,  false );
	}
	
	function _VOUCHERS() {
		JToolBarHelper::title( JText::_( 'SimpleCaddy Vouchers' )); 
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		JToolBarHelper::custom( 'control', 'back.png', 'back.png', 'Main', false,  false );
	}
	
	function _ORDERS() {
		JToolBarHelper::title( JText::_( 'SimpleCaddy Orders' )); 
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::custom( 'export', 'archive', 'archive' , 'Export', true,  false );
		JToolBarHelper::custom( 'control', 'back.png', 'back.png', 'Main', false,  false );
	}
	
	function _ABOUT() {
		JToolBarHelper::title( JText::_( 'SimpleCaddy' )); 
		JToolBarHelper::custom( 'control', 'back.png', 'back.png', 'Main', false,  false );
	}
	
	function _VIEW() {
		JToolBarHelper::title( JText::_( 'SimpleCaddy View Order' )); 
		JToolBarHelper::cancel( 'cancel', 'Close');
		JToolBarHelper::custom( 'control', 'back.png', 'back.png', 'Main', false,  false );
	}
	function _SHIPPING(){
		JToolBarHelper::title( JText::_( 'SimpleCaddy Shipping Zones' )); 
		JToolBarHelper::addnew('add');
		JToolbarHelper::save( 'edit', JText::_( 'edit' ) );
		JToolBarHelper::deleteList();
		JToolBarHelper::custom( 'control', 'back.png', 'back.png', 'Main', false,  false );
		
	}
}
?>