<?php
/**
* @package SimpleCaddy 1.72
* @copyright Copyright (C) 2006-2009 Henk von Pickartz. All rights reserved.
* GNU/GPL license
*/


// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

function com_install() {
	global $mainframe;
	$db=JFactory::getDBO();
	$query="show columns from #__sc_orders";
	$db->setQuery($query);
	$lstcf=$db->loadObjectList();
	$customfield=false;
	$ipaddress=false;
	foreach ($lstcf as $f) {
		if ($f->Field=='customfields') {
			$customfield=true;
			if ($f->Type=="varchar(255)") {
				// change the field type
				$query="ALTER TABLE `#__sc_orders` CHANGE `customfields` `customfields` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL;";
				$db->setQuery($query);
				$db->query();
				$customfield=true;
				echo "Changing customfields type to TEXT; <br />";
			}
		}
		if ($f->Field=='ipaddress') {
			$ipaddress=true;
		}
	}
	if (!$customfield) {
		// add the customfield
		$query="ALTER TABLE `#__sc_orders` ADD  `customfields` TEXT NULL;";
		$db->setQuery($query);
		$db->query();
		echo "Adding customfields to database";
	}
	if (!$ipaddress) {
		// add the customfield
		$query="ALTER TABLE `#__sc_orders` ADD  `ipaddress` varchar(32) NULL;";
		$db->setQuery($query);
		$db->query();
		echo "Adding ipaddress to database";
	}

	$db=JFactory::getDBO();
	$query="show columns from #__sc_fields";
	$db->setQuery($query);
	$lstcf=$db->loadObjectList();
	$fieldcontents=false;
	foreach ($lstcf as $f) {
		if ($f->Field=='fieldcontents') {
			$fieldcontents=true;
		}
	}
	if (!$fieldcontents) {
		// add the customfield
		$query="ALTER TABLE `#__sc_fields` ADD  `fieldcontents` TEXT NULL;";
		$db->setQuery($query);
		$db->query();
		echo "Adding fieldcontnts to database";
	}

	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(1, 'name', 'Name', 'text', 60, 'inputbox', 0, 0, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(2, 'address', 'Address', 'textarea', 0, 'inputbox', 1, 3, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(3, 'codepostal', 'Postal code / Zipcode', 'text', 10, 'inputbox', 0, 4, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(10, 'deliverybefore', 'Deliver before', 'date', 0, 'inputbox', 1, 99, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(5, 'city', 'City', 'text', 40, 'inputbox', 0, 5, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(6, 'telephone', 'Phone', 'text', 40, 'inputbox', 0, 15, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(7, 'email', 'Email', 'text', 40, 'inputbox', 0, 20, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(8, 'dropdown', 'My Dropdown Field', 'dropdown', 0, 'inputbox', 1, 0, 1, 'checkfilled', 'een;twee;drie;vier;vijf');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(11, 'div1', 'Extra info', 'divider', 0, 'divider', 0, 10, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(12, 'coupon', 'Enter coupon (if any)', 'voucher', 0, 'inputbox', 0, 0, 1, 'checkfilled', '');";
	
	foreach ($q as $key=>$query) {
		$db->setquery($query);
		$db->query();
	}

}
?>